]> git.immae.eu Git - perso/Immae/Config/Nix.git/blobdiff - nixops/scripts/setup
Refactor secrets handling
[perso/Immae/Config/Nix.git] / nixops / scripts / setup
index ff20fc91df48c16d166affd44e9eadf99ad47c77..db0f353b679429f10ccf14b60c4420489b662588 100755 (executable)
@@ -1,82 +1,90 @@
-#!/bin/bash
+#!/usr/bin/env bash
 
-RemoteRepo="gitolite@git.immae.eu:perso/Immae/Prive/Password_store/Mes_Sites/Paul"
+set -euo pipefail
 
-if [ -z "$NIXOPS_CONFIG_PASS_SUBTREE_REMOTE" \
-    -o -z "$NIXOPS_CONFIG_PASS_SUBTREE_PATH" ]; then
+if ! which nix 2>/dev/null >/dev/null; then
   cat <<-EOF
-Two environment variables are needed to setup the password store:
-NIXOPS_CONFIG_PASS_SUBTREE_PATH : path where the subtree will be imported
-NIXOPS_CONFIG_PASS_SUBTREE_REMOTE : remote name to give to the repository
-EOF
+       nix is needed, please install it:
+       > curl https://nixos.org/nix/install | sh
+       (or any other way handled by your distribution)
+       EOF
   exit 1
 fi
 
-if ! pass $NIXOPS_CONFIG_PASS_SUBTREE_PATH > /dev/null 2>/dev/null; then
+if [ "${NIX_STORE:-/nix/store}" != "/nix/store" ]; then
   cat <<-EOF
-/!\ This will modify your password store to add and import a subtree
-with the specific passwords files. Choose a path that doesn’t exist
-yet in your password store.
-> pass git remote add $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE $RemoteRepo
-> pass git subtree add --prefix=$NIXOPS_CONFIG_PASS_SUBTREE_PATH $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE master
-Later, you can use pull_environment and push_environment scripts to
-update the passwords when needed
-Continue? [y/N]
-EOF
+       Nix store outside of /nix/store is not supported
+       EOF
+  exit 1
+fi
+
+if ! which direnv 2>/dev/null >/dev/null; then
+  cat <<-EOF
+       direnv is needed, please install it
+       EOF
+  exit 1
+fi
+
+if [ -z "$NIXOPS_ENV_LOADED" ]; then
+  cat <<-EOF
+       direnv environment needs to be loaded
+       EOF
+  exit 1
+fi
+
+if [ "$(git config --get include.path)" != "../.gitconfig" ]; then
+  cat <<-EOF
+       it is recommended to include the .gitconfig file into (local) git configuration:
+       git config --local include.path '../.gitconfig'
+       Run this command? [y/N]
+       EOF
   read y
   if [ "$y" = "y" -o "$y" = "Y" ]; then
-    pass git remote add $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE $RemoteRepo
-    pass git subtree add --prefix=$NIXOPS_CONFIG_PASS_SUBTREE_PATH $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE master
-  else
-    echo "Aborting"
-    exit 1
+    git config --local include.path '../.gitconfig'
   fi
 fi
 
-if [ ! -f /etc/ssh/ssh_rsa_key_nixops ]; then
-  cat <<EOF
-The key to access private git repositories (websites hosted by the
-server) needs to be accessible to nix builders. It will be put in
-/etc/ssh/ssh_rsa_key_nixops (sudo right is needed for that)
-> pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/NixSshKey | sudo tee /etc/ssh/ssh_rsa_key_nixops > /dev/null
-> pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/NixSshKey.pub | sudo tee /etc/ssh/ssh_rsa_key_nixops.pub > /dev/null
-> sudo chmod u=r,go-rwx /etc/ssh/ssh_rsa_key_nixops
-> sudo chown nixbld1:nixbld /etc/ssh/ssh_rsa_key_nixops /etc/ssh/ssh_rsa_key_nixops.pub
-Continue? [y/N]
-EOF
-  read y
-  if [ "$y" = "y" -o "$y" = "Y" ]; then
-    if ! id -u nixbld1 2>/dev/null >/dev/null; then
-      echo "User nixbld1 seems inexistant, did you install nix?"
+for key in public_keys/*; do
+  fpr=$(cat "$key" | gpg --import-options show-only --import --with-colons | grep -e "^pub" | cut -d':' -f5)
+  gpg --list-key "$fpr" >/dev/null 2>/dev/null && imported=yes || imported=no
+  # /usr/share/doc/gnupg/DETAILS field 2
+  (cat "$key" | gpg --import-options show-only --import --with-colons |
+      grep -E '^pub:' |
+      cut -d':' -f2 |
+      grep -q '[fu]') && signed=yes || signed=no
+  if [ "$signed" = no -o "$imported" = no ] ; then
+    echo "The key for $key needs to be imported and signed (a local signature is enough)"
+    cat "$key" | gpg --import-options show-only --import
+    echo "Continue? [y/N]"
+    read y
+    if [ "$y" = "y" -o "$y" = "Y" ]; then
+      cat "$key" | gpg --import
+      gpg --expert --edit-key "$fpr" lsign quit
+    else
+      echo "Aborting"
       exit 1
     fi
-    mask=$(umask)
-    umask 0777
-    # Don’t forward it directly to tee, it would break ncurse pinentry
-    key=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/NixSshKey)
-    echo "$key" | sudo tee /etc/ssh/ssh_rsa_key_nixops > /dev/null
-    sudo chmod u=r,go=- /etc/ssh/ssh_rsa_key_nixops
-    pubkey=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/NixSshKey.pub)
-    echo "$pubkey" | sudo tee /etc/ssh/ssh_rsa_key_nixops.pub > /dev/null
-    sudo chmod a=r /etc/ssh/ssh_rsa_key_nixops.pub
-    sudo chown nixbld1:nixbld /etc/ssh/ssh_rsa_key_nixops /etc/ssh/ssh_rsa_key_nixops.pub
-    umask $mask
-  else
-    echo "Aborting"
-    exit 1
   fi
-fi
+done
 
-DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
-nix_config="ssh-config-file=$(dirname $DIR)/ssh/config"
-if echo "$NIX_PATH" | grep -q "$nix_config"; then
-  cat <<EOF
-All set up
-EOF
-else
-cat <<EOF
-All set up, please add
-ssh-config-file=$(dirname $DIR)/ssh/config
-to your NIX_PATH environment variable (colon-separated)
-EOF
+if nix show-config --json | jq -e '.sandbox.value == "true"' >/dev/null; then
+  cat <<-EOF
+       There used to be some impure derivations (grep __noChroot), you may need
+         sandbox = "relaxed"
+       in /etc/nix/nix.conf
+       you may also want to add
+         keep-outputs = true
+         keep-derivations = true
+       to prevent garbage collector from deleting build dependencies (they take a lot of time to build)
+        and
+         allow-import-from-derivation = false
+       as an attempt to avoid having build-time derivations (doesn’t work for all packages)
+       press key to continue
+       EOF
+  read y
 fi
+
+cat <<-EOF
+       All set up.
+       Please make sure you’re using make commands when deploying
+       EOF